/*
  blktest.c
  ---------
  Test driver for the block device simulator.

  $Id: blktest.c,v 1.3 2003/07/06 12:28:03 stewart Exp $

  (C)2003 Stewart Smith
  Distributed under the GNU Public License
 */

#include "block_dev.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc,char* argv[])
{
  struct block_device b;
  struct buffer_head* bh;
  int a;
  int i;
  int bsize = atoi(argv[2]);

  if(argc<3)
    {
      fprintf(stderr,"Usage:\n\t./blktest device blocksize blockcount\n\n");
      exit(0);
    }

  block_dev_init();
  block_dev_new(&b,argv[1],atoi(argv[2]),atoi(argv[3]));
  
  for(i=0;i<atoi(argv[3])/2;i++)
    {
      bh = bread(&b,i,atoi(argv[2]));
      a = write(STDOUT_FILENO,bh->b_data,bh->b_size);
    }

  for(i=atoi(argv[3])/4;i<atoi(argv[3])/2;i++)
    {
      bh = bread(&b,i,atoi(argv[2]));
      a = write(STDOUT_FILENO,bh->b_data,bh->b_size);
    }

  for(i=0;i<atoi(argv[3]);i++)
    {
      bh = bread(&b,i,atoi(argv[2]));
      a = write(STDOUT_FILENO,bh->b_data,bh->b_size);
    }

  for(i=atoi(argv[3])/4;i<atoi(argv[3])/2;i++)
    {
      bh = bread(&b,i,atoi(argv[2]));
      a = write(STDOUT_FILENO,bh->b_data,bh->b_size);
    }

  bh = bread(&b,0,bsize);
  set_buffer_dirty(bh);
  strcpy(bh->b_data,"Shut your fucking face, Uncle Fucker.");
  submit_bh(WRITE,bh);

  return 0;
}
